@typeparam TResult
@inherits JonesComponentBase
@using Microsoft.JSInterop
@using Microsoft.Extensions.Logging
@using Jones.AspNetCore.Utils
@using Jones.AspNetCore.TailwindCSS.FlowBite.Extensions

<div @attributes="@AdditionalAttributes" class="@Class" tabindex="-1" role="dialog" aria-hidden="true" data-bs-backdrop="@Backdrop" data-bs-keyboard="@KeyboardString" @ref="ModalElement">
    <CascadingValue Value="this" IsFixed="true">
        @ChildContent
    </CascadingValue>
</div>

@inject ILogger<Modal<TResult>> Logger
@inject IJSRuntime JsRuntime
@code
{
    private const string JsNamespace = "flowbiteX.modal";

    /// <summary>
    /// 获得/设置 DOM 元素实例
    /// </summary>
    private ElementReference ModalElement { get; set; }
    
    /// <summary>
    /// 获得 样式字符串
    /// </summary>
    private string? Class => CssBuilder.Default("modal")
        .AddClass("fade", IsFade)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();

    /// <summary>
    /// 获得/设置 是否后台关闭弹窗
    /// </summary>
    [Parameter]
    public bool IsBackdrop { get; set; }
    private string? Backdrop => IsBackdrop ? null : "static";

    /// <summary>
    /// 获得/设置 是否开启键盘支持 默认 true 响应键盘 ESC 按键
    /// </summary>
    [Parameter]
    public bool IsKeyboard { get; set; } = true;
    private string KeyboardString => IsKeyboard ? "true" : "false";

    /// <summary>
    /// 获得/设置 是否开启淡入淡出动画 默认为 true 开启动画
    /// </summary>
    [Parameter]
    public bool IsFade { get; set; } = true;
    
    /// <summary>
    /// 获得/设置 子组件
    /// </summary>
    [Parameter]
    public RenderFragment? ChildContent { get; set; }
    
    [Parameter]
    public Action? OnShow { get; set; }
    
    [Parameter]
    public Action? OnShown { get; set; }
    
    [Parameter]
    public Action? OnHide { get; set; }
    
    [Parameter]
    public Action? OnHidden { get; set; }
    
    [Parameter]
    public Action? OnHidePrevented { get; set; }
    
    [Parameter]
    public Action<TResult?>? OnCompleted { get; set; }

    private bool IsRendered { get; set; }

    private TaskCompletionSource<TResult?>? _returnTask;

    /// <summary>
    /// OnAfterRender 方法
    /// </summary>
    /// <param name="firstRender"></param>
    protected override void OnAfterRender(bool firstRender)
    {
        base.OnAfterRender(firstRender);

        if (firstRender)
        {
            IsRendered = true;
        }
    }
    
    /// <summary>
    /// OnAfterRenderAsync 方法
    /// </summary>
    /// <param name="firstRender"></param>
    /// <returns></returns>
    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (firstRender)
        {
            _ = RegisterOnHidden();
            if (OnShow != null)
            {
                _ = RegisterOnShow();
            }
            if (OnShown != null)
            {
                _ = RegisterOnShown();
            }
            if (OnHide != null)
            {
                _ = RegisterOnHide();
            }
            if (OnHidePrevented != null)
            {
                _ = RegisterOnHidePrevented();
            }
        }
    }

    /// <summary>
    /// Dispose 方法
    /// </summary>
    public async ValueTask DisposeAsync()
    {
        await DisposeAsyncCore(true);
        GC.SuppressFinalize(this);
    }

    /// <summary>
    /// Dispose
    /// </summary>
    /// <param name="disposing"></param>
    protected virtual async ValueTask DisposeAsyncCore(bool disposing)
    {
        if (disposing && IsRendered)
        {
            // 切换线程防止 JS 清理 DOM 后 C# 代码报错
            await Task.Delay(300);

            // JS 清理 DOM
            await DoDispose();
        }
    }
    
    /// <summary>
    /// 显示
    /// 手动打开模式文件。 在模式实际显示之前（即在 shown.bs.modal 事件发生之前）。
    /// </summary>
    /// <returns></returns>
    private ValueTask DoShow() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.show", ModalElement);

    /// <summary>
    /// 隐藏
    /// 手动隐藏模式。在实际隐藏模式之前（即 hidden.bs.modal 事件发生之前）返回调用方。
    /// </summary>
    /// <returns></returns>
    private ValueTask DoHide() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.hide", ModalElement);
    
    /// <summary>
    /// 手动更新
    /// 如果模态的高度在打开时发生变化，则手动重新调整模态的位置（即，如果出现滚动条）。
    /// </summary>
    /// <returns></returns>
    private ValueTask DoHandleUpdate() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.handleUpdate", ModalElement);

    /// <summary>
    /// 处置
    /// 销毁元素的模态。（删除DOM元素上存储的数据）
    /// </summary>
    /// <returns></returns>
    private async ValueTask DoDispose()
    {
        try
        {
            await JsRuntime.InvokeVoidAsync($"{JsNamespace}.dispose", ModalElement);
        }
        catch (Exception e)
        {
            Logger.LogError(e, "Modal DoDispose发生异常");
        }
    }
    
    /// <summary>
    /// show 调用实例方法时，将立即触发此事件。如果是由单击引起的，则clicked元素可用作 relatedTarget 事件的属性。
    /// </summary>
    /// <returns></returns>
    private ValueTask RegisterOnShow() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.onShow", 
        ModalElement, DotNetObjectReference.Create(this), nameof(OnShowCallback));
    
    /// <summary>
    /// 当模式对用户可见时将触发此事件（将等待CSS转换完成）​​。如果是由单击引起的，则clicked元素可用作 relatedTarget 事件的属性。
    /// </summary>
    /// <returns></returns>
    private ValueTask RegisterOnShown() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.onShown", 
        ModalElement, DotNetObjectReference.Create(this), nameof(OnShownCallback));

    /// <summary>
    /// 调用 hide 实例后，将立即触发此事件。
    /// </summary>
    /// <returns></returns>
    private ValueTask RegisterOnHide() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.onHide", 
        ModalElement, DotNetObjectReference.Create(this), nameof(OnHideCallback));
    
    /// <summary>
    /// 在向用户隐藏模式后，将触发此事件（将等待CSS转换完成）。
    /// </summary>
    /// <returns></returns>
    private ValueTask RegisterOnHidden() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.onHidden", 
        ModalElement, DotNetObjectReference.Create(this), nameof(OnHiddenCallback));
    
    /// <summary>
    /// 当显示模态时显示此事件，其背景为， static 并在模态外部单击或使用键盘选项或 data-bs-keyboard 将设置为来执行退出键 false。
    /// </summary>
    /// <returns></returns>
    private ValueTask RegisterOnHidePrevented() => JsRuntime.InvokeVoidAsync($"{JsNamespace}.onHidePrevented", 
        ModalElement, DotNetObjectReference.Create(this), nameof(OnHidePreventedCallback));

    [JSInvokable]
    public Task OnShowCallback()
    {
        OnShow?.Invoke();
        return Task.CompletedTask;
    }
    
    [JSInvokable]
    public Task OnShownCallback()
    {
        OnShown?.Invoke();
        
        return Task.CompletedTask;
    }
    
    [JSInvokable]
    public Task OnHideCallback()
    {
        OnHide?.Invoke();
        return Task.CompletedTask;
    }
    
    [JSInvokable]
    public async Task OnHiddenCallback()
    {
        OnHidden?.Invoke();
        if (_returnTask != null)
        {
            await Completed(default);
        }
    }
    
    [JSInvokable]
    public Task OnHidePreventedCallback()
    {
        OnHidePrevented?.Invoke();
        return Task.CompletedTask;
    }
    
    public async Task<TResult?> Show(Action? beforeShow = null)
    {
        beforeShow?.Invoke();
        await DoShow();
        _returnTask = new TaskCompletionSource<TResult?>();
        return await _returnTask.Task;
    }
    
    public async Task Complete(TResult result)
    {
        await DoHide();
        if (_returnTask != null)
        {
            await Completed(result);
        }
        OnHidden?.Invoke();
    }

    protected Task Completed(TResult? result)
    {
        SetResult(result);
        OnCompleted?.Invoke(result);
        return Task.CompletedTask;
    }

    private void SetResult(TResult? result)
    {
        _returnTask?.SetResult(result);
        _returnTask = null;
    }

    public async Task Hide() => await DoHide();
}